/* $Id: qcedump.c,v 1.2 2007/02/21 15:42:57 tamentis Exp $
 *
 * Copyright (c) 2007 Bertrand Janin <tamentis@neopulsar.org>
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR ONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE. 
 */


#include <dev/usb/usb.h>

#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "openqce.h"





void
dump_usb_flow(struct quickcam *qce)
{
	int j, i;
	FILE *dump;
	unsigned char data[65535];

	dump = fopen("dump", "a");

	/* This will read 50 packets of maximum 64k */
	for (j = 0; j < 5000; j++) {
		i = read(qce->iso_ep, data, 65535);
		fwrite(data, i, 1, dump);
	}

	fclose(dump);

}


/* 
 * Use the force Luke.
 */
int main(int ac, char **av)
{
	struct quickcam *qce;
	int ch;

	qce = quickcam_create();

	while ((ch = getopt(ac, av, "s:DdhcC")) != -1) {
		switch (ch) {
		case 'D':
			stv_full_dump(qce);
			exit(-1);
		case 'd':
			stv_dump(qce);
			exit(-1);
		case 'c':
			dump_hdcs(qce, 0);
			exit(-1);
		case 'C':
			dump_hdcs(qce, 1);
			exit(-1);
		case 'h':
		default:
			fprintf(stderr, "%s -d\n", av[0]);
			exit(-1);
		}
	}
	ac -= optind;
	av += optind;

	quickcam_init(qce);
	quickcam_capture_start(qce);

	dump_usb_flow(qce);

	quickcam_capture_stop(qce);
	quickcam_shutdown(qce); 


	exit(0);
}

